/*
    This file is part of LibQtLua.

    LibQtLua is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    LibQtLua is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with LibQtLua.  If not, see <http://www.gnu.org/licenses/>.

    Copyright (C) 2008, Alexandre Becoulet <alexandre.becoulet@free.fr>

*/

#include <QAction>

#include <QtLua/State>

int main()
{
  QtLua::State state;
  state.openlib(QtLua::QtLuaLib);
  state.enable_qdebug_print(true);

  QAction object(0);

  state["qobject"] = &object;

  state.exec_statements("for key, value in each(qobject) do print(key, value) end");

  state["qobject"] = QtLua::Value(&state);
}

